<template>
  <v-text-field
    v-bind="$attrs"
    :label="label"
    :type="passwordFieldType"
    prepend-inner-icon="mdi-lock"
    :append-icon="appendPasswordFieldIcon"
    v-on="$listeners"
    @click:append="onClickToggleShowPassword"
  />
</template>

<script>
  export default {
    name: 'PasswordField',
    props: {
      requiredPassword: {
        type: Boolean,
        required: false,
        default: false,
      },
      currentPassword: {
        type: Boolean,
        required: false,
        default: false,
      },
      newPassword: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        isShowPassword: false,
      }
    },
    computed: {
      appendPasswordFieldIcon () {
        return this.isShowPassword ? 'mdi-eye-off' : 'mdi-eye'
      },
      passwordFieldType () {
        return this.isShowPassword ? 'text' : 'password'
      },
      label () {
        const required = { required: this.requiredPassword ? '*' : '' }
        return this.currentPassword
          ? this.$t('currentPassword', required)
          : this.newPassword
            ? this.$t('newPassword', required)
            : this.$t('password', required)
      },
    },
    methods: {
      onClickToggleShowPassword () {
        this.isShowPassword = !this.isShowPassword
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          password: 'Senha{required}',
          currentPassword: 'Senha atual{required}',
          newPassword: 'Nova senha{required}',
        },
        'en-US': {
          password: 'Password{required}',
          currentPassword: 'Current password{required}',
          newPassword: 'New password{required}',
        },
      },
    },
  }
</script>
